import java.awt.*;

class Ort { 
	public double x, y, richtung; 
}

class Igel  {
	
  Graphics g;
	protected Ort meinort;
      
	public Igel( Graphics f, int x, int y, int r ) {	
		meinort = new Ort ();

		g = f;	
		meinort.x = x;	
		meinort.y = y;	
		meinort.richtung = r * (double) Math.PI / 180;
	}
   void vor( double dx ) {
		
		double xNeu = meinort.x + (double) Math.cos(meinort.richtung) * dx;
		double yNeu = meinort.y - (double) Math.sin(meinort.richtung) * dx;
		g.drawLine((int) meinort.x, (int) meinort.y, (int) xNeu, (int) yNeu );
		meinort.x = xNeu;  meinort.y = yNeu;
	}

	public void drehe( double winkel ) {
		meinort.richtung += winkel * (double) Math.PI / 180;
	}
  public void drawLine(int x1, int y1, int x2, int y2) {
    g.drawLine(x1, y1, x2, y2);
  }
}

class Peiligel extends Igel {	

  public Peiligel( Graphics g, int x, int y, int r ) {
    super(g, x, y, r);
  }	
	
	public Ort wo () {
	  return meinort;
	}

	public double peil (Ort o) {
	  double dx,dy,dist;

	  dx = o.x - meinort.x;
	  dy = o.y - meinort.y;
	  dist = Math.sqrt(dx*dx + dy*dy);

	  meinort.richtung = Math.atan2(-dy,dx); 
	  
	  return dist;
	}
 	
}

class Hedgehog extends Igel {	
  int x[] = new int[100];
  int y[] = new int[100];

  public Hedgehog( Graphics g, int x, int y, int r ) {
    super(g, x, y, r);
  }	
	
  public void blatt(int n) {
    drehe(-20);
    vor(n);
    drehe(40);
    vor(n);
    drehe(140);
    vor(n);
    drehe(40);
    vor(n);
    drehe(160);
	}
	
 	public void merkePosition(int i) {
    x[i] = (int)meinort.x;
    y[i] = (int)meinort.y;
  }
  
}