
import java.math.*; 

class euklid { // beweist, dass ggt(a,b) = k*a + n*b
               //                          (k, n ganze Zahlen)
               // und ermittelt ggf. das modular Inverse

  static void anzeigen(BigInteger z, BigInteger m,
                       BigInteger a, BigInteger b,
                       BigInteger c, BigInteger d,
                       BigInteger e, BigInteger f){
    System.out.println(a+" = ("+c+")*"+m+"+("+d+")*"+z);
    System.out.println(b+" = ("+e+")*"+m+"+("+f+")*"+z);
    System.out.println("-----------------------");
  }
  
  public static void main( String[] arg) {
    BigInteger z,m, a,c,d, b,e,f, q,r, x,y; 
    z = new BigInteger(arg[0]);
    m = new BigInteger(arg[1]);
    a = m;    b = z;
    c = new BigInteger("1");
    d = new BigInteger("0");
    e = new BigInteger("0");
    f = new BigInteger("1");
    anzeigen(z,m,a,b,c,d,e,f); 
//---------------------------------------
    while (a.mod(b).signum() > 0)
    {
      q = a.divide(b);  r = a.mod(b);
      a = b;            b = r;
      x = e;            y = f;  // e und f merken
      e = c.subtract(q.multiply(e));
      f = d.subtract(q.multiply(f));
      c = x;            d = y;
      anzeigen(z,m,a,b,c,d,e,f);
    }
    if (f.signum() < 0) f =f.add(m);
//---------------------------------------
    if (b.equals(new BigInteger("1"))) 
    {
      System.out.print("Das modular Inverse von " + z);
      System.out.println(" ist " + f);
    } else
      System.out.println("ggT("+z+","+m+") = "+b);
  }
}